Index: uspace/lib/device/src/vol.c
===================================================================
--- uspace/lib/device/src/vol.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/device/src/vol.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,610 @@
+/*
+ * Copyright (c) 2015 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libdevice
+ * @{
+ */
+/** @file Volume service API
+ */
+
+#include <abi/ipc/interfaces.h>
+#include <errno.h>
+#include <ipc/services.h>
+#include <ipc/vol.h>
+#include <loc.h>
+#include <stdlib.h>
+#include <str.h>
+#include <vfs/vfs.h>
+#include <vol.h>
+
+/** Create Volume service session.
+ *
+ * @param rvol Place to store pointer to volume service session.
+ * @return     EOK on success, ENOMEM if out of memory, EIO if service
+ *             cannot be contacted.
+ */
+errno_t vol_create(vol_t **rvol)
+{
+	vol_t *vol;
+	service_id_t vol_svcid;
+	errno_t rc;
+
+	vol = calloc(1, sizeof(vol_t));
+	if (vol == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	rc = loc_service_get_id(SERVICE_NAME_VOLSRV, &vol_svcid, 0);
+	if (rc != EOK) {
+		rc = ENOENT;
+		goto error;
+	}
+
+	vol->sess = loc_service_connect(vol_svcid, INTERFACE_VOL, 0);
+	if (vol->sess == NULL) {
+		rc = EIO;
+		goto error;
+	}
+
+	*rvol = vol;
+	return EOK;
+error:
+	free(vol);
+	return rc;
+}
+
+/** Destroy volume service session.
+ *
+ * @param vol Volume service session
+ */
+void vol_destroy(vol_t *vol)
+{
+	if (vol == NULL)
+		return;
+
+	async_hangup(vol->sess);
+	free(vol);
+}
+
+/** Get list of IDs into a buffer of fixed size.
+ *
+ * @param vol      Volume service
+ * @param method   IPC method
+ * @param arg1     First argument
+ * @param id_buf   Buffer to store IDs
+ * @param buf_size Buffer size
+ * @param act_size Place to store actual size of complete data.
+ *
+ * @return EOK on success or an error code.
+ */
+static errno_t vol_get_ids_once(vol_t *vol, sysarg_t method, sysarg_t arg1,
+    sysarg_t *id_buf, size_t buf_size, size_t *act_size)
+{
+	async_exch_t *exch = async_exchange_begin(vol->sess);
+
+	ipc_call_t answer;
+	aid_t req = async_send_1(exch, method, arg1, &answer);
+	errno_t rc = async_data_read_start(exch, id_buf, buf_size);
+
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	errno_t retval;
+	async_wait_for(req, &retval);
+
+	if (retval != EOK) {
+		return retval;
+	}
+
+	*act_size = ipc_get_arg1(&answer);
+	return EOK;
+}
+
+/** Get list of IDs.
+ *
+ * Returns an allocated array of service IDs.
+ *
+ * @param vol    Volume service
+ * @param method IPC method
+ * @param arg1   IPC argument 1
+ * @param data   Place to store pointer to array of IDs
+ * @param count  Place to store number of IDs
+ * @return       EOK on success or an error code
+ */
+static errno_t vol_get_ids_internal(vol_t *vol, sysarg_t method, sysarg_t arg1,
+    sysarg_t **data, size_t *count)
+{
+	*data = NULL;
+	*count = 0;
+
+	size_t act_size = 0;
+	errno_t rc = vol_get_ids_once(vol, method, arg1, NULL, 0, &act_size);
+	if (rc != EOK)
+		return rc;
+
+	size_t alloc_size = act_size;
+	service_id_t *ids = malloc(alloc_size);
+	if (ids == NULL)
+		return ENOMEM;
+
+	while (true) {
+		rc = vol_get_ids_once(vol, method, arg1, ids, alloc_size,
+		    &act_size);
+		if (rc != EOK)
+			return rc;
+
+		if (act_size <= alloc_size)
+			break;
+
+		alloc_size = act_size;
+		service_id_t *temp = realloc(ids, alloc_size);
+		if (temp == NULL) {
+			free(ids);
+			return ENOMEM;
+		}
+		ids = temp;
+	}
+
+	*count = act_size / sizeof(service_id_t);
+	*data = ids;
+	return EOK;
+}
+
+/** Get list of partitions as array of service IDs.
+ *
+ * @param vol Volume service
+ * @param data Place to store pointer to array
+ * @param count Place to store length of array (number of entries)
+ *
+ * @return EOK on success or an error code
+ */
+errno_t vol_get_parts(vol_t *vol, service_id_t **data, size_t *count)
+{
+	return vol_get_ids_internal(vol, VOL_GET_PARTS, 0, data, count);
+}
+
+/** Add partition.
+ *
+ * After a partition is created (e.g. as a result of deleting a label
+ * the dummy partition is created), it can take some (unknown) time
+ * until it is discovered.
+ *
+ * @param vol Volume service
+ * @param sid Service ID of the partition
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_add(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	retval = async_req_1_0(exch, VOL_PART_ADD, sid);
+	async_exchange_end(exch);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Get partition information.
+ *
+ * @param vol Volume service
+ * @param sid Service ID of the partition
+ * @param vinfo Place to store partition information
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_info(vol_t *vol, service_id_t sid, vol_part_info_t *vinfo)
+{
+	async_exch_t *exch;
+	errno_t retval;
+	ipc_call_t answer;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_1(exch, VOL_PART_INFO, sid, &answer);
+
+	errno_t rc = async_data_read_start(exch, vinfo, sizeof(vol_part_info_t));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+/** Unmount partition (and possibly eject the media).
+ *
+ * @param vol Volume service
+ * @param sid Service ID of the partition
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_eject(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	retval = async_req_1_0(exch, VOL_PART_EJECT, sid);
+	async_exchange_end(exch);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Erase partition (to the extent where we will consider it not containing
+ * a file system.
+ *
+ * @param vol Volume service
+ * @param sid Service ID of the partition
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_empty(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	retval = async_req_1_0(exch, VOL_PART_EMPTY, sid);
+	async_exchange_end(exch);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Insert volume.
+ *
+ * This will re-mount the volume if it has been ejected previously.
+ *
+ * @param vol Volume service
+ * @param sid Service ID of the partition
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_insert(vol_t *vol, service_id_t sid)
+{
+	async_exch_t *exch;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	retval = async_req_1_0(exch, VOL_PART_INSERT, sid);
+	async_exchange_end(exch);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Insert volume by path.
+ *
+ * @param vol Volume service
+ * @param path Filesystem path
+ *
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_insert_by_path(vol_t *vol, const char *path)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_0(exch, VOL_PART_INSERT_BY_PATH, &answer);
+
+	retval = async_data_write_start(exch, path, str_size(path));
+	if (retval != EOK) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return retval;
+	}
+
+	async_exchange_end(exch);
+	async_wait_for(req, &retval);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Get volume label support.
+ *
+ * @param vol Volume service
+ * @param fstype File system type
+ * @param vlsupp Place to store volume label support information
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_get_lsupp(vol_t *vol, vol_fstype_t fstype,
+    vol_label_supp_t *vlsupp)
+{
+	async_exch_t *exch;
+	errno_t retval;
+	ipc_call_t answer;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_1(exch, VOL_PART_LSUPP, fstype, &answer);
+	errno_t rc = async_data_read_start(exch, vlsupp, sizeof(vol_label_supp_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+/** Create file system.
+ *
+ * @param vol Volume service
+ * @param sid Partition service ID
+ * @param fstype File system type
+ * @param label Volume label
+ * @param mountp Mount point
+ *
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_mkfs(vol_t *vol, service_id_t sid, vol_fstype_t fstype,
+    const char *label, const char *mountp)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_2(exch, VOL_PART_MKFS, sid, fstype, &answer);
+
+	retval = async_data_write_start(exch, label, str_size(label));
+	if (retval != EOK) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return retval;
+	}
+
+	retval = async_data_write_start(exch, mountp, str_size(mountp));
+	if (retval != EOK) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return retval;
+	}
+
+	async_exchange_end(exch);
+	async_wait_for(req, &retval);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Set mount point for partition.
+ *
+ * @param vol Volume service
+ * @param sid Partition service ID
+ * @param mountp Mount point
+ *
+ * @return EOK on success or an error code
+ */
+errno_t vol_part_set_mountp(vol_t *vol, service_id_t sid,
+    const char *mountp)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	errno_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_1(exch, VOL_PART_SET_MOUNTP, sid,
+	    &answer);
+
+	retval = async_data_write_start(exch, mountp, str_size(mountp));
+	if (retval != EOK) {
+		async_exchange_end(exch);
+		async_forget(req);
+		return retval;
+	}
+
+	async_exchange_end(exch);
+	async_wait_for(req, &retval);
+
+	if (retval != EOK)
+		return retval;
+
+	return EOK;
+}
+
+/** Format file system type as string.
+ *
+ * @param fstype File system type
+ * @param rstr Place to store pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t vol_fstype_format(vol_fstype_t fstype, char **rstr)
+{
+	const char *sfstype;
+	char *s;
+
+	sfstype = NULL;
+	switch (fstype) {
+	case fs_exfat:
+		sfstype = "ExFAT";
+		break;
+	case fs_fat:
+		sfstype = "FAT";
+		break;
+	case fs_minix:
+		sfstype = "MINIX";
+		break;
+	case fs_ext4:
+		sfstype = "Ext4";
+		break;
+	case fs_cdfs:
+		sfstype = "ISO 9660";
+		break;
+	}
+
+	s = str_dup(sfstype);
+	if (s == NULL)
+		return ENOMEM;
+
+	*rstr = s;
+	return EOK;
+}
+
+/** Format partition content / file system type as string.
+ *
+ * @param pcnt Partition content
+ * @param fstype File system type
+ * @param rstr Place to store pointer to newly allocated string
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t vol_pcnt_fs_format(vol_part_cnt_t pcnt, vol_fstype_t fstype,
+    char **rstr)
+{
+	int rc;
+	char *s = NULL;
+
+	switch (pcnt) {
+	case vpc_empty:
+		s = str_dup("Empty");
+		if (s == NULL)
+			return ENOMEM;
+		break;
+	case vpc_fs:
+		rc = vol_fstype_format(fstype, &s);
+		if (rc != EOK)
+			return ENOMEM;
+		break;
+	case vpc_unknown:
+		s = str_dup("Unknown");
+		if (s == NULL)
+			return ENOMEM;
+		break;
+	}
+
+	assert(s != NULL);
+	*rstr = s;
+	return EOK;
+}
+
+/** Validate mount point.
+ *
+ * Verify that mount point is valid. A valid mount point is
+ * one of:
+ *  - 'Auto'
+ *  - 'None'
+ *  - /path (string beginning with '/') to an existing directory
+ *
+ * @return EOK if mount point is in valid, EINVAL if the format is invalid,
+ *         ENOENT if the directory does not exist
+ */
+errno_t vol_mountp_validate(const char *mountp)
+{
+	errno_t rc;
+	vfs_stat_t stat;
+
+	if (str_cmp(mountp, "Auto") == 0 || str_cmp(mountp, "auto") == 0)
+		return EOK;
+
+	if (str_casecmp(mountp, "None") == 0 || str_cmp(mountp, "none") == 0)
+		return EOK;
+
+	if (mountp[0] == '/') {
+		rc = vfs_stat_path(mountp, &stat);
+		if (rc != EOK || !stat.is_directory)
+			return ENOENT;
+
+		return EOK;
+	}
+
+	return EINVAL;
+}
+
+/** Get list of volumes as array of volume IDs.
+ *
+ * @param vol Volume service
+ * @param data Place to store pointer to array
+ * @param count Place to store length of array (number of entries)
+ *
+ * @return EOK on success or an error code
+ */
+errno_t vol_get_volumes(vol_t *vol, volume_id_t **data, size_t *count)
+{
+	return vol_get_ids_internal(vol, VOL_GET_VOLUMES, 0,
+	    (sysarg_t **) data, count);
+}
+
+/** Get volume configuration information.
+ *
+ * @param vol Volume service
+ * @param vid Volume ID
+ * @param vinfo Place to store volume configuration information
+ * @return EOK on success or an error code
+ */
+errno_t vol_info(vol_t *vol, volume_id_t vid, vol_info_t *vinfo)
+{
+	async_exch_t *exch;
+	errno_t retval;
+	ipc_call_t answer;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_1(exch, VOL_INFO, vid.id, &answer);
+
+	errno_t rc = async_data_read_start(exch, vinfo, sizeof(vol_info_t));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
+/** @}
+ */
Index: uspace/lib/display/include/disp_srv.h
===================================================================
--- uspace/lib/display/include/disp_srv.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/include/disp_srv.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -61,4 +61,5 @@
 	    gfx_coord2_t *);
 	errno_t (*window_move)(void *, sysarg_t, gfx_coord2_t *);
+	errno_t (*window_get_pos)(void *, sysarg_t, gfx_coord2_t *);
 	errno_t (*window_resize)(void *, sysarg_t, gfx_coord2_t *, gfx_rect_t *);
 	errno_t (*window_set_cursor)(void *, sysarg_t, display_stock_cursor_t);
Index: uspace/lib/display/include/display.h
===================================================================
--- uspace/lib/display/include/display.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/include/display.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -58,4 +58,5 @@
     display_wnd_rsztype_t, gfx_coord2_t *);
 extern errno_t display_window_move(display_window_t *, gfx_coord2_t *);
+extern errno_t display_window_get_pos(display_window_t *, gfx_coord2_t *);
 extern errno_t display_window_resize(display_window_t *,
     gfx_coord2_t *, gfx_rect_t *);
Index: uspace/lib/display/include/ipc/display.h
===================================================================
--- uspace/lib/display/include/ipc/display.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/include/ipc/display.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -33,6 +33,6 @@
  */
 
-#ifndef _LIBC_IPC_DISPLAY_H_
-#define _LIBC_IPC_DISPLAY_H_
+#ifndef LIBDISPLAY_IPC_DISPLAY_H
+#define LIBDISPLAY_IPC_DISPLAY_H
 
 #include <ipc/common.h>
@@ -44,4 +44,5 @@
 	DISPLAY_WINDOW_MOVE,
 	DISPLAY_WINDOW_MOVE_REQ,
+	DISPLAY_WINDOW_GET_POS,
 	DISPLAY_WINDOW_RESIZE,
 	DISPLAY_WINDOW_RESIZE_REQ,
Index: uspace/lib/display/include/types/display/cursor.h
===================================================================
--- uspace/lib/display/include/types/display/cursor.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/include/types/display/cursor.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,10 +47,12 @@
 	dcurs_size_uldr,
 	/** Double arrow pointing up-right nad down-left */
-	dcurs_size_urdl
+	dcurs_size_urdl,
+	/** I-beam (suggests editable text) */
+	dcurs_ibeam
 } display_stock_cursor_t;
 
 enum {
 	/** Number of stock cursor types */
-	dcurs_limit = dcurs_size_urdl + 1
+	dcurs_limit = dcurs_ibeam + 1
 };
 
Index: uspace/lib/display/include/types/display/wndparams.h
===================================================================
--- uspace/lib/display/include/types/display/wndparams.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/include/types/display/wndparams.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,4 +38,12 @@
 #include <gfx/coord.h>
 
+/** Window flags */
+typedef enum {
+	/** Popup window (capture events, no focus) */
+	wndf_popup = 0x1,
+	/** Set specific initial window position */
+	wndf_setpos = 0x2
+} display_wnd_flags_t;
+
 /** Parameters for a new window.
  *
@@ -50,4 +58,8 @@
 	/** Minimum size (when being resized) */
 	gfx_coord2_t min_size;
+	/** Initial position (if flag wndf_setpos is set) */
+	gfx_coord2_t pos;
+	/** Flags */
+	display_wnd_flags_t flags;
 } display_wnd_params_t;
 
Index: uspace/lib/display/src/disp_srv.c
===================================================================
--- uspace/lib/display/src/disp_srv.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/src/disp_srv.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -187,4 +187,47 @@
 }
 
+static void display_window_get_pos_srv(display_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t wnd_id;
+	ipc_call_t call;
+	gfx_coord2_t dpos;
+	size_t size;
+	errno_t rc;
+
+	wnd_id = ipc_get_arg1(icall);
+
+	if (srv->ops->window_get_pos == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	if (!async_data_read_receive(&call, &size)) {
+		async_answer_0(icall, EREFUSED);
+		return;
+	}
+
+	rc = srv->ops->window_get_pos(srv->arg, wnd_id, &dpos);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	if (size != sizeof(gfx_coord2_t)) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = async_data_read_finalize(&call, &dpos, size);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	async_answer_0(icall, EOK);
+}
+
 static void display_window_resize_req_srv(display_srv_t *srv, ipc_call_t *icall)
 {
@@ -398,4 +441,7 @@
 		case DISPLAY_WINDOW_MOVE:
 			display_window_move_srv(srv, &call);
+			break;
+		case DISPLAY_WINDOW_GET_POS:
+			display_window_get_pos_srv(srv, &call);
 			break;
 		case DISPLAY_WINDOW_RESIZE_REQ:
Index: uspace/lib/display/src/display.c
===================================================================
--- uspace/lib/display/src/display.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/src/display.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -319,4 +319,35 @@
 }
 
+/** Get display window position.
+ *
+ * Get display window position on the display.
+ *
+ * @param window Window
+ * @param dpos Place to store position
+ * @return EOK on success or an error code
+ */
+errno_t display_window_get_pos(display_window_t *window, gfx_coord2_t *dpos)
+{
+	async_exch_t *exch;
+	aid_t req;
+	ipc_call_t answer;
+	errno_t rc;
+
+	exch = async_exchange_begin(window->display->sess);
+	req = async_send_1(exch, DISPLAY_WINDOW_GET_POS, window->id, &answer);
+	rc = async_data_read_start(exch, dpos, sizeof (gfx_coord2_t));
+	async_exchange_end(exch);
+	if (rc != EOK) {
+		async_forget(req);
+		return rc;
+	}
+
+	async_wait_for(req, &rc);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
 /** Request a window resize.
  *
Index: uspace/lib/display/test/display.c
===================================================================
--- uspace/lib/display/test/display.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/display/test/display.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -59,4 +59,5 @@
 static errno_t test_window_move_req(void *, sysarg_t, gfx_coord2_t *);
 static errno_t test_window_move(void *, sysarg_t, gfx_coord2_t *);
+static errno_t test_window_get_pos(void *, sysarg_t, gfx_coord2_t *);
 static errno_t test_window_resize_req(void *, sysarg_t, display_wnd_rsztype_t,
     gfx_coord2_t *);
@@ -74,4 +75,5 @@
 	.window_move_req = test_window_move_req,
 	.window_move = test_window_move,
+	.window_get_pos = test_window_get_pos,
 	.window_resize_req = test_window_resize_req,
 	.window_resize = test_window_resize,
@@ -115,4 +117,8 @@
 	sysarg_t move_wnd_id;
 	gfx_coord2_t move_dpos;
+
+	bool window_get_pos_called;
+	sysarg_t get_pos_wnd_id;
+	gfx_coord2_t get_pos_rpos;
 
 	bool window_resize_req_called;
@@ -556,4 +562,116 @@
 }
 
+/** display_window_get_pos() with server returning error response works. */
+PCUT_TEST(window_get_pos_failure)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	gfx_coord2_t dpos;
+	test_response_t resp;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	resp.rc = EIO;
+	resp.window_get_pos_called = false;
+
+	dpos.x = 0;
+	dpos.y = 0;
+
+	rc = display_window_get_pos(wnd, &dpos);
+	PCUT_ASSERT_TRUE(resp.window_get_pos_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.get_pos_wnd_id);
+	PCUT_ASSERT_INT_EQUALS(0, dpos.x);
+	PCUT_ASSERT_INT_EQUALS(0, dpos.y);
+
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
+/** display_window_get_pos() with server returning success response works. */
+PCUT_TEST(window_get_pos_success)
+{
+	errno_t rc;
+	service_id_t sid;
+	display_t *disp = NULL;
+	display_wnd_params_t params;
+	display_window_t *wnd;
+	gfx_coord2_t dpos;
+	test_response_t resp;
+
+	async_set_fallback_port_handler(test_display_conn, &resp);
+
+	// FIXME This causes this test to be non-reentrant!
+	rc = loc_server_register(test_display_server);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = loc_service_register(test_display_svc, &sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = display_open(test_display_svc, &disp);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(disp);
+
+	resp.rc = EOK;
+	display_wnd_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p0.x = 100;
+	params.rect.p0.y = 100;
+
+	rc = display_window_create(disp, &params, &test_display_wnd_cb,
+	    (void *) &resp, &wnd);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(wnd);
+
+	resp.rc = EOK;
+	resp.window_get_pos_called = false;
+	resp.get_pos_rpos.x = 11;
+	resp.get_pos_rpos.y = 12;
+
+	dpos.x = 0;
+	dpos.y = 0;
+
+	rc = display_window_get_pos(wnd, &dpos);
+	PCUT_ASSERT_TRUE(resp.window_get_pos_called);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
+	PCUT_ASSERT_INT_EQUALS(wnd->id, resp.get_pos_wnd_id);
+	PCUT_ASSERT_INT_EQUALS(resp.get_pos_rpos.x, dpos.x);
+	PCUT_ASSERT_INT_EQUALS(resp.get_pos_rpos.y, dpos.y);
+
+	display_window_destroy(wnd);
+	display_close(disp);
+	rc = loc_service_unregister(sid);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+}
+
 /** display_window_resize_req() with server returning error response works. */
 PCUT_TEST(window_resize_req_failure)
@@ -937,6 +1055,5 @@
 	resp.rc = ENOMEM;
 	rc = display_window_get_gc(wnd, &gc);
-	/* async_connect_me_to() does not return specific error */
-	PCUT_ASSERT_ERRNO_VAL(EIO, rc);
+	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
 	PCUT_ASSERT_NULL(gc);
 
@@ -1589,4 +1706,17 @@
 }
 
+static errno_t test_window_get_pos(void *arg, sysarg_t wnd_id, gfx_coord2_t *dpos)
+{
+	test_response_t *resp = (test_response_t *) arg;
+
+	resp->window_get_pos_called = true;
+	resp->get_pos_wnd_id = wnd_id;
+
+	if (resp->rc == EOK)
+		*dpos = resp->get_pos_rpos;
+
+	return resp->rc;
+}
+
 static errno_t test_window_resize_req(void *arg, sysarg_t wnd_id,
     display_wnd_rsztype_t rsztype, gfx_coord2_t *pos)
Index: uspace/lib/drv/generic/remote_ieee80211.c
===================================================================
--- uspace/lib/drv/generic/remote_ieee80211.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/drv/generic/remote_ieee80211.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2015 Jan Kolarik
  * All rights reserved.
@@ -84,19 +85,13 @@
 }
 
-static bool mac_matches(uint8_t *mac1, uint8_t *mac2)
-{
-	for (size_t i = 0; i < ETH_ADDR; i++) {
-		if (mac1[i] != mac2[i])
-			return false;
-	}
-
-	return true;
-}
-
+// XXX This is wrong. Wifi should not have anything to do with IP links
 static sysarg_t get_link_id(uint8_t *mac)
 {
 	sysarg_t *link_list;
 	inet_link_info_t link_info;
+	eth_addr_t eth_addr;
 	size_t count;
+
+	eth_addr_decode(mac, &eth_addr);
 
 	errno_t rc = inetcfg_get_link_list(&link_list, &count);
@@ -109,5 +104,5 @@
 			return -1;
 
-		if (mac_matches(mac, link_info.mac_addr))
+		if (eth_addr_compare(&eth_addr, &link_info.mac_addr) == 0)
 			return link_list[i];
 	}
@@ -170,4 +165,6 @@
 		return rc;
 
+	// XXX This is wrong. Wifi should not initiate DHCP
+
 	/* Send DHCP discover. */
 	nic_address_t wifi_mac;
@@ -207,4 +204,7 @@
 	if (rc != EOK)
 		return rc;
+
+	eth_addr_t eth_addr;
+	eth_addr_decode(wifi_mac.address, &eth_addr);
 
 	inet_link_info_t link_info;
@@ -215,4 +215,6 @@
 	size_t count;
 
+	/// XXX This is wrong. Wifi should do nothing with DHCP
+
 	/* Remove previous DHCP address. */
 	rc = inetcfg_get_addr_list(&addr_list, &count);
@@ -229,5 +231,5 @@
 			return rc;
 
-		if (mac_matches(wifi_mac.address, link_info.mac_addr)) {
+		if (eth_addr_compare(&eth_addr, &link_info.mac_addr) == 0) {
 			if (str_test_prefix(addr_info.name, "dhcp")) {
 				rc = inetcfg_addr_delete(addr_list[i]);
Index: uspace/lib/drv/include/battery_iface.h
===================================================================
--- uspace/lib/drv/include/battery_iface.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/drv/include/battery_iface.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc
+/** @addtogroup libdrv
  * @{
  */
Index: uspace/lib/drv/include/ieee80211_iface.h
===================================================================
--- uspace/lib/drv/include/ieee80211_iface.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/drv/include/ieee80211_iface.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc
+/** @addtogroup libdrv
  * @{
  */
Index: uspace/lib/drv/include/nic_iface.h
===================================================================
--- uspace/lib/drv/include/nic_iface.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/drv/include/nic_iface.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libc
+/** @addtogroup libdrv
  * @{
  */
Index: uspace/lib/drv/meson.build
===================================================================
--- uspace/lib/drv/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/drv/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'pcm' ]
+deps = [ 'inet', 'pcm', 'device' ]
 private_includes += include_directories('generic/private')
 src = files(
Index: uspace/lib/fdisk/meson.build
===================================================================
--- uspace/lib/fdisk/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/fdisk/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'device' ]
 src = files('src/fdisk.c')
